
#include "stdafx.h"
#include "Clinka.h"

// kopirovaci konstruktor
CLinka::CLinka(const CLinka & l)
{
	zacatek = l.Zacatek();
	konec = l.Konec();
}

// operator prirazeni
const CLinka & CLinka::operator=(const CLinka & l)
{
	zacatek = l.Zacatek();
	konec = l.Konec();
	return l;
}

// konstruktor ktery pouzivame my
CLinka::CLinka(const CPoint & zac, const CPoint & kon)
{
	zacatek = zac;
	konec = kon;
}

CPoint CLinka::Zacatek() const
{
	return zacatek;
}


CPoint CLinka::Konec() const
{
	return konec;
}

// serializace
void CLinka::Serialize(CArchive & ar)
{
	if (ar.IsStoring())
	{ // jsme volani s archivem otevrenym pro zapis, tak zapisujeme
		ar << zacatek.x << zacatek.y << konec.x << konec.y;
	}
	else
	{ // jsme volani, abychom si data nacetli
		ar >> zacatek.x >> zacatek.y >> konec.x >> konec.y;
	}
}

// potrebuje MFC, aby trida byla serializovatelna
// 1. param - nazev nasi tridy
// 2. param - nazev predka
// 3. param - cislo verze zpusobu ulozeni dat, kdyz se zmeni metoda Serialize(), je treba zmenit i cislo,
// aby nedoslo k nekorektnimu nacitani dat ze starych souboru
IMPLEMENT_SERIAL(CLinka, CObject, 1)

