#ifndef _CLINKA_H_
#define _CLINKA_H_

//
//!!! trida, ktera reprezentuje jednu caru na okne. Je serializovatelna, cili splnuje nasledujici veci:
// - je potomkem CObject
// - deklaruje DECLARE_SERIAL a v cpp souboru IMPLEMENT_SERIAL
// - ma konstruktor bez parametru
// - implementuje metodu Serialize()
//
class CLinka : public CObject
{
private:
	// dva body, konce linky
	CPoint zacatek;
	CPoint konec;

public:
	// bezparametricky konstruktor, aby MFC mohlo tridu vytvorit a pak volat metodu Serialize(), ktera
	// naplni objekt daty
	CLinka() {}

	// kopirovaci konstruktor a operator=, aby mohla trida byt v CArray (Kdybychom schovavali jen ukazatele
	// na linku, nemuselo by to byt, ale pak bychom museli alokovat dynamicky a starat se o uvolnovani.
	// CLinka je mala trida, takze kopirovani je rychle
	CLinka(const CLinka & l);
	const CLinka & operator=(const CLinka & l);

	// konstruktor ktery pouzivame my pri vytvareni linky ze dvou bodu
	CLinka(const CPoint & zac, const CPoint & kon);
	// vrati bod kde linka zacina
	CPoint  Zacatek() const;
	// vrati bod kde linka konci
	CPoint Konec() const;

	// implementuje serializaci
	virtual void Serialize(CArchive & ar);

	// je treba, aby trida byla serializovatelna
	DECLARE_SERIAL(CLinka)
};

#endif