// JednoduchyEditorView.cpp : implementation of the CJednoduchyEditorView class
//

#include "stdafx.h"
#include "JednoduchyEditor.h"

#include "JednoduchyEditorDoc.h"
#include "JednoduchyEditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CJednoduchyEditorView

IMPLEMENT_DYNCREATE(CJednoduchyEditorView, CView)

BEGIN_MESSAGE_MAP(CJednoduchyEditorView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_CHAR()
	ON_WM_LBUTTONDOWN() //!!!
END_MESSAGE_MAP()

// CJednoduchyEditorView construction/destruction

CJednoduchyEditorView::CJednoduchyEditorView()
{
	minulyBodPlatny = FALSE;
}

CJednoduchyEditorView::~CJednoduchyEditorView()
{
}

BOOL CJednoduchyEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CJednoduchyEditorView drawing

void CJednoduchyEditorView::OnDraw(CDC* pDC)
{
	CJednoduchyEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	CRect oblast;
	GetClientRect(&oblast);

	// napis text
	pDC->DrawText(pDoc->GetString(), &oblast, DT_WORDBREAK);

	//!!! nakresli cary
	//!!! zjistime si ukazatel na CArray s linkami
	const CArray<CLinka, CLinka> * linky = pDoc->GetLines();
	//!!! a vsechny vykresilme
	for (int i = 0; i < linky->GetSize(); i++)
	{
		//!!! ziska i-ty prvek pole
		CLinka l = linky->GetAt(i);
		//!!! posune pozici kresleni na zacatek linky
		pDC->MoveTo(l.Zacatek());
		//!!! nakresli linku od aktualni pozice kresleni k danemu bodu (konci linky)
		pDC->LineTo(l.Konec());
	}
}


// CJednoduchyEditorView printing

BOOL CJednoduchyEditorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CJednoduchyEditorView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CJednoduchyEditorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CJednoduchyEditorView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{

	if (nChar == 8)
		GetDocument()->Backspace();
	else
		GetDocument()->AddChar((TCHAR)nChar);
	
}


//!!! Obsluha udalosti po kliknuti levym tlacitkem mysi
void CJednoduchyEditorView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (!minulyBodPlatny) //!!! minuly bod co si pamatujeme uz byl zapsan
	{
		//!!! zapamatujeme si aktualni bod, je to zacatek dalsi cary
		minulyBod = point;
		minulyBodPlatny = TRUE;
		return;
	}

	//!!! minule kliknuti byl zacatek, ted mame konec - vytvarime linku a
	// zapisujeme do dokumentu
	GetDocument()->AddLine(CLinka(minulyBod, point));
	//!!! minuly bod byl pouzit, zneplatnime ho
	minulyBodPlatny = FALSE;
}

// CJednoduchyEditorView diagnostics

#ifdef _DEBUG
void CJednoduchyEditorView::AssertValid() const
{
	CView::AssertValid();
}

void CJednoduchyEditorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CJednoduchyEditorDoc* CJednoduchyEditorView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CJednoduchyEditorDoc)));
	return (CJednoduchyEditorDoc*)m_pDocument;
}

#endif //_DEBUG


// CJednoduchyEditorView message handlers
